<?php
class support_data_class{
	
	public function __construct(){
 		add_action( 'init', array( $this, 'support_ticket_validate' ) );
	}
	
	public function support_ticket_validate(){
	
		if(isset($_REQUEST['action']) and sanitize_text_field($_REQUEST['action']) == 'add_ticket'){
			start_session_if_not_started();
			$error = false;
			$msg = '';
			$mc = new support_message_class;
			$ticket_subject = sanitize_text_field($_REQUEST['ticket_subject']);
			$ticket_body = esc_html($_REQUEST['ticket_body']);
			
			if ( ! isset( $_POST['support_form_action_field'] ) || ! wp_verify_nonce( $_POST['support_form_action_field'], 'support_form_action' ) ) {
			   wp_die( 'Sorry, your nonce did not verify.');
			} 
			
			if(!is_user_logged_in()){
				$error = true;
				$msg .= __('Please login to create ticket.','wp-support-ticket').'<br>';
			}
			if(!$ticket_subject){
				$error = true;
				$msg .= __('Please enter ticket subject.','wp-support-ticket').'<br>';
			}
			if(!$ticket_body){
				$error = true;
				$msg .= __('Please enter ticket message.','wp-support-ticket').'<br>';
			}
			
			if(!$error){
				$data = array('ticket_subject' => $ticket_subject, 'ticket_body' => $ticket_body);
				$rc = new reply_class;
				$ret = $rc->insert_ticket($data);
				
				if(!$ret){
					$error = true;
					$msg = __('Error: Ticket cannot be created.','wp-support-ticket');
					$mc->add_message($msg,'bg-danger');
				} else {
					$msg = __('Support ticket created successfully.','wp-support-ticket');
					$mc->add_message($msg,'bg-success');
				}
			} else {
				$mc->add_message($msg,'bg-danger');
			}
		}
		
		if(isset($_REQUEST['action']) and sanitize_text_field($_REQUEST['action']) == 'add_reply'){
			start_session_if_not_started();
			$error = false;
			$msg = '';
			$mc = new support_message_class;
			
			$ticket_body = esc_html($_REQUEST['ticket_body']);
			
			if ( ! isset( $_POST['support_form_action_field'] ) || ! wp_verify_nonce( $_POST['support_form_action_field'], 'support_form_action' ) ) {
			   wp_die( 'Sorry, your nonce did not verify.');
			} 
			
			if(!is_user_logged_in()){
				$error = true;
				$msg .= __('Please login to add reply.','wp-support-ticket').'<br>';
			}
			if(!$ticket_body){
				$error = true;
				$msg .= __('Please enter reply message.','wp-support-ticket').'<br>';
			}
			
			if(!$error){
				$data = array( 'ticket_body' => $ticket_body);
				$rc = new reply_class(sanitize_text_field($_REQUEST['ticket_id']));
				$ret = $rc->insert_ticket_reply($data);
				
				if(!$ret){
					$error = true;
					$msg = __('Error: Reply cannot be created.','wp-support-ticket');
					$mc->add_message($msg,'bg-danger');
				} else {
					$msg = __('Reply added successfully.','wp-support-ticket');
					$mc->add_message($msg,'bg-success');
				}
			} else {
				$mc->add_message($msg,'bg-danger');
			}
		}
	}
	
}

new support_data_class;