<?php
class wp_support_settings {
	
	public function __construct() {
		add_action( 'admin_menu', array( $this, 'wp_support_afo_menu' ) );
		add_action( 'plugins_loaded',  array( $this, 'wp_support_ticket_text_domain' ) );
		add_action( 'admin_init',  array( $this, 'wp_support_save_settings' ) );
		add_action( 'wp_enqueue_scripts', array( $this, 'wp_support_ticket_scripts' ) );
		add_action( 'admin_enqueue_scripts', array( $this, 'wp_support_ticket_scripts' ) );
	}
	
	public function wp_support_ticket_scripts() {
		wp_enqueue_style( 'style-support', plugins_url('assets/style-support.css', __FILE__));
		wp_enqueue_script( 'jquery' );
		wp_enqueue_script( 'jquery.cookie', plugin_dir_url( __FILE__ ) . 'js/jquery.cookie.js' );
		wp_enqueue_script( 'ap-tabs', plugin_dir_url( __FILE__ ) . 'js/ap-tabs.js' );
	}
	
	public function wp_support_ticket_text_domain(){
		load_plugin_textdomain('wp-support-ticket', FALSE, basename( dirname( __FILE__ ) ) .'/languages');
	}
	
	public function  wp_support_afo_options() {
		echo '<div class="wrap">';
		
		global $wpdb;
		$support_admin_email = get_option('support_admin_email');
		$support_admin_from_email = get_option('support_admin_from_email');
		$ticket_sc_page = get_option('ticket_sc_page');
		$ticket_before_login_message_create = stripslashes(get_option('ticket_before_login_message_create'));
		$ticket_before_login_message_search = stripslashes(get_option('ticket_before_login_message_search'));
		$ticket_before_login_message_list = stripslashes(get_option('ticket_before_login_message_list'));
		
		$this->show_message();
		
		$this->wp_recommended_plugins_add();
		$this->help_support();
		
		form_class::form_open();
		wp_nonce_field( 'wp_support_save_action', 'wp_support_save_action_field' );
    	form_class::form_input('hidden','option','','wp_support_save_settings');
		?>
		<table border="0" style="background:#FFFFFF; width:100%; padding:10px; margin:5px 0px; border:1px solid #ccc;"> 
		  <tr>
			<td colspan="2"><h3><?php _e('WP Support Settings','wp-support-ticket');?></h3></td>
		  </tr>
          <tr>
			<td colspan="2">
                <div class="ap-tabs">
                    <div class="ap-tab"><?php _e('Email Settings','wp-support-ticket');?></div>
                    <div class="ap-tab"><?php _e('Other Settings','wp-support-ticket');?></div>
                    <div class="ap-tab"><?php _e('Shortcodes','wp-support-ticket');?></div>
                </div>
                <div class="ap-tabs-content">
                    <div class="ap-tab-content">
                    <table width="100%">
                      <tr>
                        <td valign="top" width="300"><strong><?php _e('Admin Email','wp-support-ticket');?></strong></td>
                        <td><?php form_class::form_input('text','support_admin_email','',$support_admin_email,'','','','','50','',false,__('admin@example.com','wp-support-ticket'));?>
                            <br />
                            <i><?php
                            printf( esc_html__( 'This email will be used when support ticket related emails are sent. (When new ticket is created by user, User add a reply to a ticket etc) %s version has option to edit Email Body and use Email Templates.', 'wp-support-ticket' ), '<a href="https://www.aviplugins.com/wp-support-pro/" target="_blank">PRO</a>' );
                            ?>
                            </i></td>
                      </tr>
                      <tr>
                      <td colspan="2">&nbsp;</td>
                      </tr>
		 			  <tr>
                        <td valign="top"><strong><?php _e('From Email','wp-support-ticket');?>:</strong></td>
                        <td><?php form_class::form_input('text','support_admin_from_email','',$support_admin_from_email,'','','','','50','',false,__('no-reply@example.com','wp-support-ticket'));?>
                        <br>
                        <i><?php _e('Enter From Email so that emails do not go to SPAM folder','wp-support-ticket');?></i>
                            </td>
                      </tr>
                      <tr>
                      	<td colspan="2">&nbsp;</td>
                      </tr>
                      <tr>
                      	<td>&nbsp;</td>
                      	<td><?php form_class::form_input('submit','submit','',__('Save','wp-support-ticket'),'button button-primary button-large','','','','','',false,'');?></td>
                      </tr>
                      </table>
                    </div>
                    <div class="ap-tab-content">
                    <table width="100%">
                       <tr>
                        <td valign="top" width="300"><strong><?php _e('Ticket Shortcode Page','wp-support-ticket');?></strong></td>
                        <td><?php
                                $args = array(
                                'depth'            => 0,
                                'selected'         => $ticket_sc_page,
                                'echo'             => 1,
                                'show_option_none' => '-',
                                'id' 			   => 'ticket_sc_page',
                                'name'             => 'ticket_sc_page'
                                );
                                wp_dropdown_pages( $args ); 
                            ?><font color="red"><?php _e('Important','wp-support-ticket');?></font>
                            <br />
                            <i><?php _e('Please create a new page and put the shortcode <strong>[ticket]</strong> in the page and select that page here. Please do not use that page as Front page.','wp-support-ticket');?></i></td>
                      </tr>
                       <tr>
                        <td colspan="2">&nbsp;</td>
                      </tr>
                       <tr>
                        <td valign="top"><strong><?php _e('Before Login Message Ticket Create','wp-support-ticket');?></strong><p><i><?php _e('If user is not logged in then this message will be displayed with <strong>[create_support]</strong> shortcode.','wp-support-ticket');?></i></p></td>
                        <td><?php form_class::form_textarea('ticket_before_login_message_create','',$ticket_before_login_message_create,'','','','','3','50','','Please login to create support ticket. [login_widget]');?><br><?php _e('HTML tags and shortcodes are allowed','wp-support-ticket');?></td>
                      </tr>
                       <tr>
                        <td colspan="2">&nbsp;</td>
                      </tr>
                       <tr>
                        <td valign="top"><strong><?php _e('Before Login Message Ticket Search','wp-support-ticket');?></strong><p><i><?php _e('If user is not logged in then this message will be displayed with <strong>[ticket_search]</strong> shortcode.','wp-support-ticket');?></i></p></td>
                        <td><?php form_class::form_textarea('ticket_before_login_message_search','',$ticket_before_login_message_search,'','','','','3','50','','Please login to search ticket. [login_widget]');?><br><?php _e('HTML tags and shortcodes are allowed','wp-support-ticket');?></td>
                      </tr>
                       <tr>
                        <td colspan="2">&nbsp;</td>
                      </tr>
                       <tr>
                        <td valign="top"><strong><?php _e('Before Login Message Ticket List','wp-support-ticket');?></strong>
                        <p><i><?php _e('If user is not logged in then this message will be displayed with <strong>[ticket]</strong> shortcode.','wp-support-ticket');?></i></p></td>
                        <td><?php form_class::form_textarea('ticket_before_login_message_list','',$ticket_before_login_message_list,'','','','','3','50','','Please login to view support ticket. [login_widget]');?><br><?php _e('HTML tags and shortcodes are allowed','wp-support-ticket');?></td>
                      </tr>
                      <tr>
                      	<td colspan="2">&nbsp;</td>
                      </tr>
                      <tr>
                      	<td>&nbsp;</td>
                      	<td><?php form_class::form_input('submit','submit','',__('Save','wp-support-ticket'),'button button-primary button-large','','','','','',false,'');?></td>
                      </tr>
                      </table>
                    </div>
                    <div class="ap-tab-content">
                    <table width="100%">
                          <tr>
                        <td>
                        <p>1. <strong>[create_support]</strong> to display Create New Support Ticket Form.</p>
                        <p>2. <strong>[ticket]</strong> to display Tickets Created by User. User must me logged in to view support ticket created by him/ her.</p>
                        <p>3. <strong>[ticket_search]</strong> to display Ticket Search Form.</p>
                        </td>
                      </tr>
          			  <tr>
                        <td><hr /></td>
                      </tr>
		 			<tr>
                        <td>
                        <font color="red"><strong><?php _e('Note','wp-support-ticket');?>*</strong></font><br>
                        <p>1. If you face <strong>Page Not Found</strong> issue when visiting the ticket details page please update the <a href="options-permalink.php">Permalinks</a> settings.</p>
                        <p>2. If you are using permalinks for your site then your permalink structure should contain <strong>%supticket%</strong>.</p>
                        <p>For example, if your permalink looks like this <strong>/%postname%/</strong> then you should change that to <strong>/%postname%/%supticket%/</strong>. <strong>This is not mandatory</strong>.</p>
                        
                        </td>
                      </tr>
                      </table>
                    </div>
                </div>
            </td>
		  </tr>
		</table>
		<?php 
		form_class::form_close();
		$this->support_ticket_pro_add();
		$this->donate();
		echo '</div>';
	}
	
	public function show_message(){
		if(isset($GLOBALS['msg'])){
			echo '<div class="updated notice notice-success"><p>'.$GLOBALS['msg'].'</p></div>';
		}
	}
	
	public function wp_recommended_plugins_add(){ ?>
	<table width="100%" border="0" style="background-color:#FFFFFF; border:1px solid #CCCCCC; padding:5px 0px 0px 10px; margin:5px 0px;">
  <tr>
    <td><p><strong>WP Support (PRO)</strong> recommends you to download and activate <a href="https://wordpress.org/plugins/login-sidebar-widget/" target="_blank">Login Widget With Shortcode</a> and <a href="https://wordpress.org/plugins/wp-register-profile-with-shortcode/" target="_blank">WP Register Profile With Shortcode</a> from <a href="https://wordpress.org/" target="_blank">wordpress.org</a>, so that users can <strong>Login</strong> and <strong>Register</strong> in your site.</p></td>
  </tr>
</table>
	<?php }
	
	public function support_ticket_pro_add(){ ?>
	<table border="0" style="width:100%; background-color:#FFFFD2; border:1px solid #E6DB55; padding:5px 0px 0px 10px; margin:5px 0px;">
  <tr>
    <td><p>There is a <strong>PRO</strong> version of this plugin that supports additional features. Create Support <strong>Agents</strong>, Lets users upload <strong>Multiple Files</strong> with <strong>Drag & Drop</strong>, Create <strong>Custom Fields</strong> in ticket form, Manage body of <strong>Emails</strong> with <strong>Email Templates</strong> and more. Check it out <a href="https://www.aviplugins.com/wp-support-pro/" target="_blank">here</a> in details. Get it in <a href="https://www.aviplugins.com/wp-support-pro/" target="_blank"><strong>USD 2.00</strong></a></p></td>
  </tr>
</table>
	<?php }
	
	public function donate(){	?>
	<table width="100%" border="0" style="background-color:#FFF; border:1px solid #ccc; margin:5px 0px; padding-right:10px;">
	 <tr>
	 <td align="right"><a href="https://www.aviplugins.com/donate/" target="_blank">Donate</a> <img src="<?php echo  plugin_dir_url( __FILE__ ) . '/images/paypal.png';?>" style="vertical-align: middle;" alt="PayPal"></td>
	  </tr>
	</table>
	<?php
	}
	
	public function help_support(){ ?>
	<table border="0" style="width:100%; background-color:#FFFFFF; border:1px solid #CCC; padding:5px; margin:5px 0px;">
	  <tr>
		<td align="right"><a href="https://www.aviplugins.com/support.php" target="_blank">Help and Support</a> <a href="https://www.aviplugins.com/rss/news.xml" target="_blank"><img src="<?php echo  plugin_dir_url( __FILE__ ) . '/images/rss.png';?>" style="vertical-align: middle;" alt="RSS"></a></td>
	  </tr>
	</table>
	<?php
	}
	
	
	public function wp_support_save_settings(){
		if(isset($_POST['option']) and $_POST['option'] == "wp_support_save_settings"){
			
			if ( ! isset( $_POST['wp_support_save_action_field'] ) || ! wp_verify_nonce( $_POST['wp_support_save_action_field'], 'wp_support_save_action' ) ) {
			   wp_die( 'Sorry, your nonce did not verify.');
			} 
			
			update_option( 'ticket_sc_page', sanitize_text_field($_POST['ticket_sc_page']) );
			update_option( 'support_admin_from_email', sanitize_text_field($_POST['support_admin_from_email']) );
			update_option( 'support_admin_email', sanitize_text_field($_POST['support_admin_email']) );
			update_option( 'ticket_before_login_message_create', esc_html($_POST['ticket_before_login_message_create']) );
			update_option( 'ticket_before_login_message_search', esc_html($_POST['ticket_before_login_message_search']) );
			update_option( 'ticket_before_login_message_list', esc_html($_POST['ticket_before_login_message_list']) );	
			
			$GLOBALS['msg'] = 'Data updated successfully.';
		}
	}
	
	public function wp_support_afo_menu () {
		add_options_page( 'WP Support', 'WP Support', 'activate_plugins', 'wp_support_afo', array( $this, 'wp_support_afo_options' ));
	}
	
}
new wp_support_settings;