<?php
class create_support_sc_class{
	
	public $ticket_before_login_message_create;
	
	public function __construct(){
		add_shortcode( 'create_support', array( $this, 'create_support_ticket_function' ) );
		$ticket_before_login_message_create = stripslashes(get_option('ticket_before_login_message_create'));
		if( empty($ticket_before_login_message_create) ){
			$this->ticket_before_login_message_create = __('Please login to create support ticket.','wp-support-ticket');
		} else {
			$this->ticket_before_login_message_create = html_entity_decode($ticket_before_login_message_create);
		}
	}
	
	public function create_support_ticket_function( $atts ) {
		$a = shortcode_atts( array(
			'title' => '',
		), $atts );
	
		if(is_user_logged_in()){
		ob_start();
		$mc = new support_message_class;
		$mc->show_message();
		?>
		<?php if($a['title']){?>
		<h2><?php echo $a['title']; ?> </h2>
		<?php } ?>
        
        <?php
		form_class::form_open('f','','post','','multipart/form-data');
		wp_nonce_field( 'support_form_action', 'support_form_action_field' );
		form_class::form_input('hidden','action','','add_ticket');
		?>
		  <div class="form-group">
			<label for="subject"><?php _e('Subject','wp-support-ticket');?></label>
            <?php form_class::form_input('text','ticket_subject','ticket_subject','','form-control','','','','','',false,__('Ticket Title','wp-support-ticket'));?>
		  </div>
		  <div class="form-group">
			<label for="message"><?php _e('Message','wp-support-ticket');?></label>
            <?php form_class::form_textarea('ticket_body','','','form-control');?>
		  </div>
		  
		  <div class="form-group">
            <?php form_class::form_input('file','safile','safile');?>
		  </div>
		  
          <?php form_class::form_input('submit','submit','',__('Submit','wp-support-ticket'),'btn btn-default','','','','','',false,'');?>
          
		<?php form_class::form_close();?>
		<?php
		$ret = ob_get_clean();	
		} else {
		$ret = do_shortcode($this->ticket_before_login_message_create);	
		}
		return $ret;
	}
	
}

class ticket_sc_class{
	
	public $ticket_before_login_message_search;
	
	public $ticket_before_login_message_list;
	
	public function __construct(){
		add_shortcode( 'ticket_details', array( $this, 'ticket_details_function' ) );
		add_shortcode( 'ticket_list', array( $this, 'ticket_list_function' ) );
		add_shortcode( 'ticket', array( $this, 'ticket_function' ) );
		add_shortcode( 'ticket_search', array( $this, 'ticket_search_function' ) );
	}
	
	public function ticket_search_function( $atts ) {
		$a = shortcode_atts( array(
			'title' => '',
		), $atts );
		
		$ticket_before_login_message_search = stripslashes(get_option('ticket_before_login_message_search'));
		
		if( empty($ticket_before_login_message_search) ){
			$this->ticket_before_login_message_search = __('Please login to search ticket.','wp-support-ticket');
		} else {
			$this->ticket_before_login_message_search = html_entity_decode($ticket_before_login_message_search);
		}
					
		if(is_user_logged_in()){
		ob_start();
		$rc = new reply_class();
		?>
		<?php if($a['title']){?>
		<h2><?php echo $a['title']; ?> </h2>
		<?php } ?>
        
        <?php
		form_class::form_open('search','','get',get_permalink(get_option('ticket_sc_page')));
		form_class::form_input('hidden','action','','srch_ticket');
		?>
        <table width="100%" border="0">
  <tbody>
    <tr>
      <td><div class="support-form-group">
                <?php form_class::form_input('text','st_title','','','support-search-form-control','','','','','',false,__('Ticket','wp-support-ticket'));?>

			  </div></td>
      <td>
      <?php form_class::form_input('submit','submit','',__('Search','wp-support-ticket'),'btn btn-default','','','','','',false,'');?>
     </td>
    </tr>
  </tbody>
</table>
<?php form_class::form_close();?>

		<?php
		$ret = ob_get_clean();	
		} else {
		$ret = do_shortcode($this->ticket_before_login_message_search);	
		}
		return $ret;
	}
	
	public function ticket_details_function( $atts ) {
		$a = shortcode_atts( array(
			'id' => '',
		), $atts );
		$id = $a['id'];
		if(!$id)
		return;
		
		$ticket_before_login_message_list = stripslashes(get_option('ticket_before_login_message_list'));
		
		if( empty($ticket_before_login_message_list) ){
			$this->ticket_before_login_message_list = __('Please login to view support ticket.','wp-support-ticket');
		} else {
			$this->ticket_before_login_message_list = html_entity_decode($ticket_before_login_message_list);
		}
		
		if(is_user_logged_in()){
		ob_start();
		$ticket = get_post( $id );
		
		if(!$ticket){
			return;
		}
		if ( $ticket->post_author != get_current_user_id() )  {
			return;
		}
		global $ticket_status_array;
		$mc = new support_message_class;
		$mc->show_message();
		$ticket_status = get_post_meta( $id, '_ticket_status', true );
		?>
		<h2><?php echo get_the_title( $id ); ?> </h2>
		<h4 class="status"><?php _e('Status','wp-support-ticket');?> <?php echo $ticket_status_array[$ticket_status]; ?> </h4>
        
        <?php
		form_class::form_open('f','','post','','multipart/form-data');
		wp_nonce_field( 'support_form_action', 'support_form_action_field' );
		form_class::form_input('hidden','action','','add_reply');
		form_class::form_input('hidden','ticket_id','',$id);
		?>
			  <div class="form-group">
				<label for="exampleInputPassword1"><?php _e('Message','wp-support-ticket');?></label>
                <?php form_class::form_textarea('ticket_body','','','form-control','','','','3');?>
			  </div>
			  
			  <div class="form-group">
				<?php form_class::form_input('file','safile','safile');?>
		   	  </div>
		  
           <?php form_class::form_input('submit','submit','',__('Submit','wp-support-ticket'),'btn btn-default','','','','','',false,'');?>
		  
		<?php form_class::form_close();?>
        
		<?php
		$this->get_ticket_reply($id);
		$ret = ob_get_clean();	
		} else {
		$ret = do_shortcode($this->ticket_before_login_message_list);	
		}
		return $ret;
	}
	
	public static function tick_details_link($id){
		if(!$id){
			return;
		}
		
		if(get_option('permalink_structure') != ''){
			$link = get_permalink(get_option('ticket_sc_page')).'details/'.$id;
		} else {
			if(is_front_page()){
				$link = '#';
			} else {
				$link = get_permalink(get_option('ticket_sc_page')).'&view=details&supticket='.$id;
			}
		}
		return $link;
	}
	
	public function ticket_list_function( $atts ) {
		$a = shortcode_atts( array(
			'title' => '',
		), $atts );
		$title = $a['title'];
		
		$ticket_before_login_message_list = stripslashes(get_option('ticket_before_login_message_list'));
		
		if( empty($ticket_before_login_message_list) ){
			$this->ticket_before_login_message_list = __('Please login to view support ticket.','wp-support-ticket');
		} else {
			$this->ticket_before_login_message_list = html_entity_decode($ticket_before_login_message_list);
		}
		
		if(is_user_logged_in()){
		ob_start();
		global $ticket_status_array;
		$rc = new reply_class;
		$data = $rc->get_user_tickets(get_current_user_id());
		?>
		<?php if($title){?>
		<h2><?php echo $title;?></h2>
		<?php } ?>
		<table class="support-list-table table-hover">
		  <thead>
			<tr>
			  <th><?php _e('#','wp-support-ticket');?></th>
			  <th><?php _e('Ticket','wp-support-ticket');?></th>
			  <th><?php _e('Status','wp-support-ticket');?></th>
			  <th><?php _e('Last Post By','wp-support-ticket');?></th>
			</tr>
		  </thead>
		  <tbody>
		    <?php
		 	 if ( $data->have_posts() ) {
		 	 while ( $data->have_posts() ) { 
			 $data->the_post();
			 $ticket_status = get_post_meta( $data->post->ID, '_ticket_status', true );
			 ?>
				<tr>
				  <td><a href="<?php echo $this->tick_details_link($data->post->ID);?>"><?php echo $data->post->ID; ?></a></td>
				  <td><a href="<?php echo $this->tick_details_link($data->post->ID);?>"><?php echo get_the_title(); ?></a></td>
				  <td><?php echo $ticket_status_array[$ticket_status]; ?></td>
				  <td><?php echo $rc->last_post_by($data->post->ID); ?></td>
				</tr>
			<?php 
				} // end of loop
			} else { ?>
			<tr>
			  <td colspan="4" align="center"><?php _e('Support ticket not found','wp-support-ticket');?></td>
			</tr>
			<?php } ?>
		  </tbody>
		</table>
		
		<?php
		$big = 999999999;
		echo paginate_links( array(
			'base' => str_replace( $big, '%#%', esc_url( get_pagenum_link( $big ) ) ),
			'format' => '?paged=%#%',
			'prev_text' => __('Previous','wp-support-ticket'),
			'next_text' => __('Next','wp-support-ticket'),
			'current' => max( 1, get_query_var('paged') ),
			'total' => $data->max_num_pages
		) );
		$ret = ob_get_clean();	
		} else {
		$ret = do_shortcode($this->ticket_before_login_message_list);	
		}
		return $ret;
	}
	
	public function get_ticket_reply($id = ''){
		if(!$id)
		return;
		$rc = new reply_class( $id );
		$data = $rc->get_reply_data();
	
		if($data){
			foreach($data as $key => $value){
		?>
            <div class="media-body">
                <div class="pull-left">
                    <?php echo $rc->reply_user_avatar($value->user_id);?>
                </div>
            	<div class="pull-right">
                <h4 class="media-heading"><?php echo $rc->get_reply_user_name($value->user_id);?>
                    <small><?php echo $rc->reply_post_date($value->reply_added);?></small>
                </h4>
                <?php echo stripslashes($value->reply_msg);?>
                <div class="attachments"><?php $this->get_attachments($value->reply_id);?></div>
                </div>
            </div>
		<?php 
			} // end of foreach
		} else { 
			_e('No reply posted yet.','wp-support-ticket');
		}
		noti_class::update_reply_noti_user( $id );
	}
	
	public function get_attachments($reply_id){
		$rc = new reply_class;
		$data = $rc->get_attachments_data($reply_id);
		if($data){
			_e('Attachments:','wp-support-ticket');
			foreach($data as $key => $value){
				echo '<a href="'.$value->att_file.'" target="_blank"><img style="border:none;" src="'.plugins_url('assets/attach.png', __FILE__).'"></a>';
			}
		}
	}
	
	public function ticket_function( $atts ) {
		$a = shortcode_atts( array(
			'title' => '',
		), $atts );
		
		$ticket = get_query_var( 'supticket' );
		
		ob_start();
		if(!$ticket){
			$ret = $this->get_ticket_list($a['title']);
		} else {
			$ret = $this->get_ticket_details($ticket);
		}
		$ret = ob_get_clean();	
		return $ret;
	}
	
	public function get_ticket_details($ticket = ''){
		echo do_shortcode('[ticket_details id="'.$ticket.'"]');
	}
	
	public function get_ticket_list($title = ''){
		echo do_shortcode('[ticket_list title="'.$title.'"]');
	}
	
}

new create_support_sc_class;
new ticket_sc_class;